<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// 验证并获取合法的ID，如果不合法将其设定为-1
$cat_id = $firewall->get_legal_id('solution_category', $_REQUEST['cat_id'], $_REQUEST['unique_id']);
if ($cat_id == -1 || $cat_id == 0)
    $cat_id = $dou->get_one("SELECT cat_id FROM " . $dou->table('solution_category') . " ORDER BY sort ASC, cat_id ASC");

$where = ' WHERE cat_id IN (' . $cat_id . $dou->dou_child_id('solution_category', $cat_id) . ')';

// 未加入分页条件的SQL语句
$sql = "SELECT * FROM " . $dou->table('solution') . $where . " ORDER BY sort ASC, id DESC";

// 获取分页信息
$page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
$limit = $dou->pager($sql, 10, $page);

/* 获取产品列表 */
$sql = $sql . $limit; // 加入分页条件的SQL语句
$query = $dou->query($sql);
while ($row = $dou->fetch_array($query)) {
    // 如果描述不存在则自动从详细介绍中截取
    $description = $row['description'] ? $row['description'] : $dou->dou_substr($row['content'], 150, false);
    
    // 对应的分类信息
    $cate_info_row = $dou->get_row('solution_category', 'cat_id, cat_name', "cat_id = '$row[cat_id]'");
    $cate_info_row['url'] = $dou->rewrite_url_miniprogram('solution_category', $row['cat_id']);
    
    $solution_list[] = array (
            "id" => $row['id'],
            "cat_id" => $row['cat_id'],
            "title" => $row['title'],
            "image" => $dou->dou_file($row['image']),
            "defined" => $dou->format_defined($row['defined']),
            "add_time" => date("Y-m-d", $row['add_time']),
            "description" => $description,
            "click" => $row['click'],
            "url" => $dou->rewrite_url_miniprogram('solution', $row['id']),
            "cate_info" => $cate_info_row
    );
}

// 获取分类信息
$cate_info = $dou->get_row('solution_category', '*', "cat_id = '$cat_id'");

// 数据封装
$data['title'] = $cate_info ? $cate_info['cat_name'] : $_LANG['solution'];
$data['cat_id'] = $cat_id;
$data['solution_list'] = $solution_list;
$data['solution_category'] = $dou->get_category('solution_category', 0, $cat_id);
$data['cate_info'] = $cate_info;

echo json_encode($data);

?>